﻿using System.Windows;
using System.Windows.Input;

namespace ViewModel
{
    public class MainViewModel : ViewModelBase
    {
        public MainViewModel()
        {
            Status = new StatusBarViewModel();
            Worker = new WorkerViewModel(Status);
            Status.StatusText = "Fertig - Warte auf Benutzer";       //Dieser Text wird angezeigt
        }

        private WorkerViewModel _worker;
        public WorkerViewModel Worker
        {
            get
            {
                return _worker;
            }
            set
            {
                _worker = value;
                RaisePropertyChanged();
            }
        }

        private StatusBarViewModel _status;
        public StatusBarViewModel Status
        {
            get
            {
                return _status;
            }
            set
            {
                _status = value;
                RaisePropertyChanged();
            }
        }

        private ICommand _clickCommand;
        public ICommand ClickCommand
        {
            get
            {
                if (_clickCommand == null)
                    _clickCommand = new RelayCommand(DieMethodeFuerExecute, null);
                return _clickCommand;
            }
        }
        private void DieMethodeFuerExecute(object obj)
        {
            MessageBox.Show("Bis hierher ist alles klar");
            Status.StatusText = "Wird nicht angezeigt - Warum nicht?";
        }
        //private bool DieMethodeFuerCanExecute(object obj)
        //{
        //    // Prüfen ob man klicken darf - Button wir dann Disabled oder Enabled
        //    //return true; // Hier das Ergebniss zurückgeben

        //    return true;
        //}
        private ICommand _exitCommand;
        public ICommand ExitCommand
        {
            get
            {
                if (_exitCommand == null)
                    _exitCommand = new RelayCommand(ExitMethode, null);
                return _exitCommand;
            }
        }
        private void ExitMethode(object obj)
        {
            Application.Current.Shutdown();
        }
    }
}
